//+------------------------------------------------------------------+
//|                                             AdvancedSAR_v1_0.mq4 |
//|                                          Copyright  2008, Xaron |
//|                                             http://www.xaron.net |
//|                                                                  |
//| This EA was created by Xaron: xaron@gmx.eu                       |
//|                                                                  |
//| Special thanks goes to FXTradePro for this great idea of         |
//| a sequence of trades and Rama for his EA and effort.             |
//|                                                                  |
//| This EA may NOT be sold and is licensed under the GPL:           |
//|                                                                  |
//|        http://www.gnu.org/copyleft/gpl.html                      |
//|                                                                  |
//| That means, any changes and additions must be distributed        |
//| together with the source code!                                   |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Xaron"
#property link      "http://www.xaron.net"

#include <stdlib.mqh>
#include <stderror.mqh> // Handles errors
#include <info.mq4>     // Handles information displayed on chart
#include <log.mq4>      // Creates and manages expert log file

extern string ExpertName       = "Advanced SAR v1.0";
extern bool   AccountIsMini    = true;
extern double AllowedSlippage  = 10.0;
extern color  LabelColor1      = OrangeRed;
extern color  LabelColor2      = OrangeRed;

extern string EntryOptions             = "-= Entry Options =-";
extern bool   FirstOrderLong           = true;
extern bool   StopTradingAfterSequence = false;
extern bool   UseTimeEntry             = true;
extern int    EntryHour                = 9;
extern int    EntryMinute              = 0;
extern int    StopHour                 = 16;
extern int    StopMinute               = 0;
extern bool   UsePriceEntry            = false;
extern double EntryPrice               = 0.0;

extern string PositionSizeSettings = "-= Position Size Settings =-";
extern double PSize1  = 0.01;
extern double SL1     = 20.0;
extern double TP1     = 20.0;
extern double PSize2  = 0.02;
extern double SL2     = 20.0;
extern double TP2     = 20.0;
extern double PSize3  = 0.04;
extern double SL3     = 20.0;
extern double TP3     = 20.0;
extern double PSize4  = 0.08;
extern double SL4     = 20.0;
extern double TP4     = 20.0;
extern double PSize5  = 0.16;
extern double SL5     = 20.0;
extern double TP5     = 20.0;
extern double PSize6  = 0.16;
extern double SL6     = 20.0;
extern double TP6     = 40.0;
extern double PSize7  = 0.16;
extern double SL7     = 20.0;
extern double TP7     = 80.0;
extern double PSize8  = 0.16;
extern double SL8     = 20.0;
extern double TP8     = 160.0;
extern double PSize9  = 0.00;
extern double SL9     = 0.0;
extern double TP9     = 0.0;
extern double PSize10 = 0.00;
extern double SL10    = 0.0;
extern double TP10    = 0.0;
extern double PSize11 = 0.00;
extern double SL11    = 0.0;
extern double TP11    = 0.0;
extern double PSize12 = 0.00;
extern double SL12    = 0.0;
extern double TP12    = 0.0;
extern double PSize13 = 0.00;
extern double SL13    = 0.0;
extern double TP13    = 0.0;
extern double PSize14 = 0.00;
extern double SL14    = 0.0;
extern double TP14    = 0.0;
extern double PSize15 = 0.00;
extern double SL15    = 0.0;
extern double TP15    = 0.0;
extern double PSize16 = 0.00;
extern double SL16    = 0.0;
extern double TP16    = 0.0;
extern double PSize17 = 0.00;
extern double SL17    = 0.0;
extern double TP17    = 0.0;
extern double PSize18 = 0.00;
extern double SL18    = 0.0;
extern double TP18    = 0.0;
extern double PSize19 = 0.00;
extern double SL19    = 0.0;
extern double TP19    = 0.0;
extern double PSize20 = 0.00;
extern double SL20    = 0.0;
extern double TP20    = 0.0;

//Static variable for later retrieve 
//on EA reloading (e.g. after unnormal computer shut down).
static int _currentProgressionLevel = 1;
static int _lastOrderTicket = 0;
static bool _stopTrading = false;

string _versionNumber = "1.0";
int _magicNumber = 0;
int _lotDigits = 1;
int _numberOfTries = 10;  // how often may the EA try to open a position/order
int _error;
string _text, _text1, _text2, _text3, _text4, _text5;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
  // Set the Magic numbers
  if( Symbol() == "AUDCADm" || Symbol() == "AUDCAD" ) { _magicNumber = 95741001; }
  if( Symbol() == "AUDJPYm" || Symbol() == "AUDJPY" ) { _magicNumber = 95741002; }
  if( Symbol() == "AUDNZDm" || Symbol() == "AUDNZD" ) { _magicNumber = 95741003; }
  if( Symbol() == "AUDUSDm" || Symbol() == "AUDUSD" ) { _magicNumber = 95741004; }
  if( Symbol() == "CHFJPYm" || Symbol() == "CHFJPY" ) { _magicNumber = 95741005; }
  if( Symbol() == "EURAUDm" || Symbol() == "EURAUD" ) { _magicNumber = 95741006; }
  if( Symbol() == "EURCADm" || Symbol() == "EURCAD" ) { _magicNumber = 95741007; }
  if( Symbol() == "EURCHFm" || Symbol() == "EURCHF" ) { _magicNumber = 95741008; }
  if( Symbol() == "EURGBPm" || Symbol() == "EURGBP" ) { _magicNumber = 95741009; }
  if( Symbol() == "EURJPYm" || Symbol() == "EURJPY" ) { _magicNumber = 95741010; }
  if( Symbol() == "EURUSDm" || Symbol() == "EURUSD" ) { _magicNumber = 95741011; }
  if( Symbol() == "GBPCHFm" || Symbol() == "GBPCHF" ) { _magicNumber = 95741012; }
  if( Symbol() == "GBPJPYm" || Symbol() == "GBPJPY" ) { _magicNumber = 95741013; }
  if( Symbol() == "GBPUSDm" || Symbol() == "GBPUSD" ) { _magicNumber = 95741014; }
  if( Symbol() == "NZDJPYm" || Symbol() == "NZDJPY" ) { _magicNumber = 95741015; }
  if( Symbol() == "NZDUSDm" || Symbol() == "NZDUSD" ) { _magicNumber = 95741016; }
  if( Symbol() == "USDCHFm" || Symbol() == "USDCHF" ) { _magicNumber = 95741017; }
  if( Symbol() == "USDJPYm" || Symbol() == "USDJPY" ) { _magicNumber = 95741018; }
  if( Symbol() == "USDCADm" || Symbol() == "USDCAD" ) { _magicNumber = 95741019; }
  if( Symbol() == "XAUUSDm" || Symbol() == "XAUUSD" ) { _magicNumber = 95741020; }
  if( Symbol() == "XAGUSDm" || Symbol() == "XAGUSD" ) { _magicNumber = 95741021; }
  if( _magicNumber == 0 ) { _magicNumber = 95741999; }
  if( AccountIsMini ) { _lotDigits = 2; }

  // Creates a log.txt file to save events information from expert execution
  string logFile = DoubleToStr( _magicNumber, 0 );
  log_open( logFile );
  log( "Log file successfully opened at " + TimeToStr( TimeCurrent(), TIME_DATE ) );
  log( "Sequencer version: " + _versionNumber );

  // Creates Labels text for information display
  info_init(false);
  info_clear();

  if( IsTradeAllowed() || IsExpertEnabled() )
  {
    info( 0, ExpertName + " EA is allowed to trade.", LabelColor1, 8 );
    info( 1, "On first tick this message will desapear.", LabelColor2 );
  }
  else
    info( 0, ExpertName + " EA is not allowed to trade.", Red, 8 );

  // The following code is only for getting the last orders back
  // in case of that the EA was stopped by any reason (crash, etc.)
  // Check for any open trades from the last session to resume
  int openOrders = OrdersTotal();
  for( int i = 0; i < openOrders; i++ )
  {
    OrderSelect( i, SELECT_BY_POS, MODE_TRADES );
    if( OrderMagicNumber() == _magicNumber )
    {
      // Open Order found!
      // Get the last used progression level from the comment of the order
      _currentProgressionLevel = StrToInteger( OrderComment() ) + 1;
      _lastOrderTicket = OrderTicket();
      _text = "Found an active order - ticket: " + DoubleToStr( _lastOrderTicket, 0 ) +
        " - progression: " + DoubleToStr( _currentProgressionLevel, 0 );
      log( _text );
      Print( _text );
      break;  // nothing more to do, we've found our order
    }
  }

  return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
  Comment( "" );
  info_clear();
  info_deinit();
  int deInitReason = UninitializeReason();
  switch( deInitReason )
  {
    case 0: _text  = "Normal deinit. No forced causes";                          break;
    case 1: _text  = "REASON_REMOVE: Expert removed from chart";                 break;
    case 2: _text  = "REASON_RECOMPILE: Expert recompiled";                      break;
    case 3: _text  = "REASON_CHARTCHANGE: Symbol or timeframe changed on chart"; break;
    case 4: _text  = "REASON_CHARTCLOSE: Chart closed or Test Stopped";          break;
    case 5: _text  = "REASON_PARAMETERS: Input parameters were changed by user"; break;
    case 6: _text  = "REASON_ACCOUNT: Other account activated";                  break;
    default: _text = "Deinit reason not defined";                                break;
  }
  log( "Reason for deinitialization: " + deInitReason + " " + _text );
 
  log( "Close log file, the expert has finished work at " +
    TimeToStr( TimeCurrent(), TIME_DATE ) + " ---------------------------------");
  log_close();
  return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----
  if( !IsTesting() )
  {
    if( !IsExpertEnabled() || !IsTradeAllowed() )
      return(8);
  }
  _text1 = "";
  _text2 = "";
  _text3 = "";
  _text4 = "";
  _text5 = "";
  if( _stopTrading )
  {
    _text1 = "Trading has been stopped.";
    _text2 = "";
    _text3 = "";
    _text4 = "";
    _text5 = "";
    // if the extern variable has been reset, start a new sequence!
    if( !StopTradingAfterSequence )
    {
      // Check if the last progression level is still running...
      int openOrders = OrdersTotal();
      for( int i = 0; i < openOrders; i++ )
      {
        OrderSelect( i, SELECT_BY_POS, MODE_TRADES );
        if( OrderMagicNumber() == _magicNumber )
          break;  // Yes, there is still an open order, don't restart yet...
        else
        {
          _stopTrading = false;
          _currentProgressionLevel = 1;
          _lastOrderTicket = 0;
          break;
        }
      }
    } 
  }
  else
  {
    // Trading is allowed, show the info labels
    _text1 = "Magic: " + DoubleToStr( _magicNumber, 0 ) +
      " - Floating P/L: " + DoubleToStr( OrderProfit() + OrderSwap(), 2 );
    _text2 = "Progression Sequence Level: " + DoubleToStr( _currentProgressionLevel, 0 );
    _text3 = "Current Lot Size: " + DoubleToStr( GetPositionSize( _currentProgressionLevel ), _lotDigits );
    _text4 = "Next Lot Size: " + DoubleToStr( GetPositionSize( _currentProgressionLevel + 1 ), _lotDigits );
    _text5 = "";

    // ===================== TIME ENTRY =====================
    if( UseTimeEntry )
    {
      // start time
      datetime periodStart = MathFloor( TimeCurrent() / 86400 ) * 86400 +
        EntryHour * 3600 + EntryMinute * 60;
      // just use a time entry window of one minute!
      datetime periodEntryEnd = periodStart + 60;
      // stop time
      datetime periodStop = MathFloor( TimeCurrent() / 86400 ) * 86400 +
        StopHour * 3600 + StopMinute * 60;
      datetime now = TimeCurrent();
      // Do we have an open position already?
      if( _lastOrderTicket == 0 )
      {
        // ... no, so wait for the time entry
        // time entry reached, open a new position
        if( now >= periodStart && now < periodEntryEnd )
        {
          _text = "Time Entry reached!";
          Print( _text );
          log( _text );
          // Get the correct position size
          double posSizeTE = GetPositionSize( _currentProgressionLevel );
          double stopLossTE = GetStopLoss( _currentProgressionLevel );
          double takeProfitTE = GetTakeProfit( _currentProgressionLevel );
          int typeOfOrderTE = OP_SELL;
          if( FirstOrderLong )
            typeOfOrderTE = OP_BUY;

          _lastOrderTicket = NewOrder( typeOfOrderTE, posSizeTE, stopLossTE, takeProfitTE );
          if( _lastOrderTicket < 0 )
            return(9);

          _currentProgressionLevel++;
          if( GetPositionSize( _currentProgressionLevel ) == 0.0 )
          {
            if( StopTradingAfterSequence )
              _stopTrading = true;
            _currentProgressionLevel = 1;
            _lastOrderTicket = 0;
          }
        }
        else
          _text5 = "Waiting for time entry!";
      }
      else  // there is already a position open, check for stop and reverse
      {
        // are we still allowed to trade?
        if( now > periodStart && now < periodStop )
        {
          if( ManageOpenPositions() < 0 )
            return(9);
        }
      }
    }
    // ===================== PRICE ENTRY =====================
    else if( UsePriceEntry )
    {
      // Do we have an open position already?
      int typeOfOrderPE = 0;
      if( _lastOrderTicket == 0 )
      {
        bool doEnterPE = false;
        if( FirstOrderLong )
        {
          if( Ask >= EntryPrice )
            doEnterPE = true;
          typeOfOrderPE = OP_BUY;
        }
        else
        {
          if( Bid <= EntryPrice )
            doEnterPE = true;
          typeOfOrderPE = OP_SELL;
        }
        if( doEnterPE )
        { 
          _text = "Price Entry reached!";
          Print( _text );
          log( _text );
          // Get the correct position size
          double posSizePE = GetPositionSize( _currentProgressionLevel );
          double stopLossPE = GetStopLoss( _currentProgressionLevel );
          double takeProfitPE = GetTakeProfit( _currentProgressionLevel );
          _lastOrderTicket = NewOrder( typeOfOrderPE, posSizePE, stopLossPE, takeProfitPE );
          if( _lastOrderTicket < 0 )
            return(9);
          _currentProgressionLevel++;
          if( GetPositionSize( _currentProgressionLevel ) == 0.0 )
          {
            if( StopTradingAfterSequence )
              _stopTrading = true;
            _currentProgressionLevel = 1;
            _lastOrderTicket = 0;
          }
        }
        else
          _text5 = "Waiting for a price entry!";
      }
      else  // there is already a position open, check for stop and reverse
      {
        if( ManageOpenPositions() < 0 )
          return(9);
      }
    }
    // ===================== MANUAL ENTRY =====================
    else // otherwise open directly a new position
    {
      // Do we have an open position already?
      if( _lastOrderTicket == 0 )
      {
        _text = "Manual price entry!";
        Print( _text );
        log( _text );
        // Get the correct position size
        double posSizeDE = GetPositionSize( _currentProgressionLevel );
        double stopLossDE = GetStopLoss( _currentProgressionLevel );
        double takeProfitDE = GetTakeProfit( _currentProgressionLevel );
        int typeOfOrderDE = OP_SELL;
        if( FirstOrderLong )
          typeOfOrderDE = OP_BUY;

        _lastOrderTicket = NewOrder( typeOfOrderDE, posSizeDE, stopLossDE, takeProfitDE );
        if( _lastOrderTicket < 0 )
          return(9);

        _currentProgressionLevel++;
        if( GetPositionSize( _currentProgressionLevel ) == 0.0 )
        {
          if( StopTradingAfterSequence )
            _stopTrading = true;
          _currentProgressionLevel = 1;
          _lastOrderTicket = 0;
        }
      }
      else  // there is already a position open, check for stop and reverse
      {
        if( ManageOpenPositions() < 0 )
          return(9);
      }
    }
  }
   
  // Display information on top left corner.   
  info( 0, _text1, LabelColor1, 8 );
  info( 1, _text2, LabelColor2 );
  info( 2, _text3, LabelColor2 );
  info( 3, _text4, LabelColor2 );
  info( 4, _text5, LabelColor2 );  
//----
  return(0);
}
//+------------------------------------------------------------------+

// Function to manage the open positions
// It checks for closed positions and enters the next progression if necessary
int ManageOpenPositions()
{
  if( OrderSelect( _lastOrderTicket, SELECT_BY_TICKET ) )
  {
    if( OrderMagicNumber() == _magicNumber )
    {
      // Was the order closed?
      if( OrderCloseTime() > 0 )
      {
        if( OrderType() == OP_BUY )
        {
          // Was the order closed in profit?
          if( OrderClosePrice() >= OrderTakeProfit() )
          {
            _text = "Order " + OrderTicket() + " closed with profit at " +
              DoubleToStr( OrderClosePrice(), Digits ) + ".";
            Print( _text );
            log( _text );
            if( StopTradingAfterSequence )
              _stopTrading = true;
            _currentProgressionLevel = 1;
            _lastOrderTicket = 0;
          }
          else if( OrderClosePrice() <= OrderStopLoss() )
          {
            _text = "Order " + OrderTicket() + " hit its stop loss at " +
              DoubleToStr( OrderClosePrice(), Digits ) + ".";
            Print( _text );
            log( _text );
            EnterNextProgression();
            if( _lastOrderTicket < 0 )
              return(9);
          }
        }
        else if( OrderType() == OP_SELL )
        {
          // Was the order closed in profit?
          if( OrderClosePrice() <= OrderTakeProfit() )
          {
            _text = "Order " + OrderTicket() + " closed with profit at " +
              DoubleToStr( OrderClosePrice(), Digits ) + ".";
            Print( _text );
            log( _text );
            if( StopTradingAfterSequence )
              _stopTrading = true;
            _currentProgressionLevel = 1;
            _lastOrderTicket = 0;
          }
          else if( OrderClosePrice() >= OrderStopLoss() )
          {
            _text = "Order " + OrderTicket() + " hit its stop loss at " +
              DoubleToStr( OrderClosePrice(), Digits ) + ".";
            Print( _text );
            log( _text );
            EnterNextProgression();
            if( _lastOrderTicket < 0 )
              return(9);
          }
        }
      }
    }
  }
}

// Enters the next progression level if there is one
void EnterNextProgression()
{
  int lastOrderType = OrderType();
  // Get the correct position size
  double posSize = GetPositionSize( _currentProgressionLevel );
  double stopLoss = GetStopLoss( _currentProgressionLevel );
  double takeProfit = GetTakeProfit( _currentProgressionLevel );
  int typeOfOrder = OP_SELL;
  if( lastOrderType == OP_SELL )
    typeOfOrder = OP_BUY;

  _lastOrderTicket = NewOrder( typeOfOrder, posSize, stopLoss, takeProfit );
  _currentProgressionLevel++;
  if( GetPositionSize( _currentProgressionLevel ) == 0.0 )
  {
    if( StopTradingAfterSequence )
      _stopTrading = true;
    _currentProgressionLevel = 1;
    _lastOrderTicket = 0;
  }
}

// Opens a new order with several tries if the first attempt doesn't work
// Returns the new order ticket
int NewOrder( int typeOfOrder, double positionSize, double stopLoss, double takeProfit )
{
//----
  double sl = 0.0;
  double tp = 0.0;
  double price = 0.0;
  color arrowColor = Green;
  for( int i = 1 ; i <= _numberOfTries; i++ )
  {
    if( typeOfOrder == OP_BUY )
    {
      price = NormalizeDouble( Ask, Digits );
      sl = price - stopLoss * MarketInfo( Symbol(), MODE_POINT );
      tp = price + takeProfit * MarketInfo( Symbol(), MODE_POINT );
    }
    else
    {
      price = NormalizeDouble( Bid, Digits );
      sl = price + stopLoss * MarketInfo( Symbol(), MODE_POINT );
      tp = price - takeProfit * MarketInfo( Symbol(), MODE_POINT );
      arrowColor = Red;
    }
    int ticket = OrderSend( Symbol(), typeOfOrder, positionSize, price,
      AllowedSlippage, sl, tp, DoubleToStr( _currentProgressionLevel, 0 ), _magicNumber, 0, arrowColor );

    if( ticket < 1 )
    {
      _error = GetLastError(); 
      _text = "Error: " + _error + " " + ErrorDescription( _error ) +
        " Price: " + price + " SL: " + sl + " TP: " + tp + " Retry: " + i + "/" + _numberOfTries;
      Print( _text );
      log( _text );
      Sleep( 10000 );
    }
    else
    {
      _text = "Ticket opened by EA :" + ticket + " " + _text;
      Print( _text );
      log( _text );
      break;
    }
  }
         
  if( ticket < 1 )
  {
    _error = GetLastError();
    _text = "Could not open order: " + DoubleToStr( positionSize, 2 ) + " lots of " +
      Symbol() + " at price " + DoubleToStr( price, Digits );

    Print( _text );
    log( _text );

    _text = "Error: " + _error + " - " + ErrorDescription( _error );
    Print( _text );
    log( _text );
  }
  return( ticket );
}

// Returns the position size for the parameter progression level
double GetPositionSize( int ProgressionLevel )
{
  double pSize = 0.0;
  switch( ProgressionLevel )
  {
    case 1:
      pSize = PSize1;
      break;
    case 2:
      pSize = PSize2;
      break;
    case 3:
      pSize = PSize3;
      break;
    case 4:
      pSize = PSize4;
      break;
    case 5:
      pSize = PSize5;
      break;
    case 6:
      pSize = PSize6;
      break;
    case 7:
      pSize = PSize7;
      break;
    case 8:
      pSize = PSize8;
      break;
    case 9:
      pSize = PSize9;
      break;
    case 10:
      pSize = PSize10;
      break;
    case 11:
      pSize = PSize11;
      break;
    case 12:
      pSize = PSize12;
      break;
    case 13:
      pSize = PSize13;
      break;
    case 14:
      pSize = PSize14;
      break;
    case 15:
      pSize = PSize15;
      break;
    case 16:
      pSize = PSize16;
      break;
    case 17:
      pSize = PSize17;
      break;
    case 18:
      pSize = PSize18;
      break;
    case 19:
      pSize = PSize19;
      break;
    case 20:
      pSize = PSize20;
      break;
    default:
      pSize = 0.0;
      break;
  }
  return ( pSize );
}

// Returns the stop loss for the parameter progression level
double GetStopLoss( int ProgressionLevel )
{
  double sl = 0.0;
  switch( ProgressionLevel )
  {
    case 1:
      sl = SL1;
      break;
    case 2:
      sl = SL2;
      break;
    case 3:
      sl = SL3;
      break;
    case 4:
      sl = SL4;
      break;
    case 5:
      sl = SL5;
      break;
    case 6:
      sl = SL6;
      break;
    case 7:
      sl = SL7;
      break;
    case 8:
      sl = SL8;
      break;
    case 9:
      sl = SL9;
      break;
    case 10:
      sl = SL10;
      break;
    case 11:
      sl = SL11;
      break;
    case 12:
      sl = SL12;
      break;
    case 13:
      sl = SL13;
      break;
    case 14:
      sl = SL14;
      break;
    case 15:
      sl = SL15;
      break;
    case 16:
      sl = SL16;
      break;
    case 17:
      sl = SL17;
      break;
    case 18:
      sl = SL18;
      break;
    case 19:
      sl = SL19;
      break;
    case 20:
      sl = SL20;
      break;
    default:
      sl = 0.0;
      break;
  }
  return( sl );
}

// Returns the take profit for the parameter progression level
double GetTakeProfit( int ProgressionLevel )
{
  double tp = 0.0;
  switch( ProgressionLevel )
  {
    case 1:
      tp = TP1;
      break;
    case 2:
      tp = TP2;
      break;
    case 3:
      tp = TP3;
      break;
    case 4:
      tp = TP4;
      break;
    case 5:
      tp = TP5;
      break;
    case 6:
      tp = TP6;
      break;
    case 7:
      tp = TP7;
      break;
    case 8:
      tp = TP8;
      break;
    case 9:
      tp = TP9;
      break;
    case 10:
      tp = TP10;
      break;
    case 11:
      tp = TP11;
      break;
    case 12:
      tp = TP12;
      break;
    case 13:
      tp = TP13;
      break;
    case 14:
      tp = TP14;
      break;
    case 15:
      tp = TP15;
      break;
    case 16:
      tp = TP16;
      break;
    case 17:
      tp = TP17;
      break;
    case 18:
      tp = TP18;
      break;
    case 19:
      tp = TP19;
      break;
    case 20:
      tp = TP20;
      break;
    default:
      tp = 0.0;
      break;
  }
  return( tp );
}

